#!/usr/bin/perl -w

# next install project is to guess where different things are using 'which'
#   and the PATH variable

# script names

$script[0] = "irefile";
$script[1] = "ifilter";



# gets parent working directory

open(PWD, "echo \$PWD | ") || die "Couldn't get PWD\n";

$_ = <PWD>;
chop;
$cur_dir = $_;

close(PWD);

if ($cur_dir =~ m/[^\/]$/) { $cur_dir .= "/"; }



print "In the following questions, you may simply press \'Enter\' to accept ";
print "the default.\n\n";


# get the location of mh binaries
# program expects 'rmm' executable to be in $refile_dir also

# /usr/local/bin/... is another likely place

$refile_default = "/usr/bin/mh/";

print "What directory is your mh refile binary in? [ $refile_default ] ";

$refile_dir = <STDIN>;
chop $refile_dir;

if ($refile_dir eq "") { $refile_dir = $refile_default; }
if ($refile_dir =~ m/[^\/]$/) { $refile_dir .= "/"; }
print "Refile dir = $refile_dir\n";



# get the location of mh library functions

# /usr/local/lib/ is another likely place

$rcvstore_default = "/usr/lib/mh/";

print "What directory is your mh rcvstore binary in? [ $rcvstore_default ] ";

$rcvstore_dir = <STDIN>;
chop $rcvstore_dir;

if ($rcvstore_dir eq "") { $rcvstore_dir = $rcvstore_default; }
if ($rcvstore_dir =~ m/[^\/]$/) { $rcvstore_dir .= "/"; }
print "Rcvstore dir = $rcvstore_dir\n";



# get the location of perl

$perl_default = "/usr/bin/";

print "What directory is your perl binary located in? [ $perl_default ] ";

$perl_dir = <STDIN>;
chop $perl_dir;

if ($perl_dir eq "") { $perl_dir = $perl_default; }
if ($perl_dir =~ m/[^\/]$/) { $perl_dir .= "/"; }
print "Perl dir = $perl_dir\n";



# gets the user's home directory to perform modification of .maildelivery file

$home_default = "";
$home_dir = "";

while ($home_dir eq "") 
{
       print "Where is your home directory? [ $home_default ] ";
       $home_dir = <STDIN>;
       chop $home_dir;

       if (($home_dir eq "") || ($home_dir =~ m/root/)) {
	   print "\nI need the directory of YOUR user account.\n\n";
	   $home_dir = "";
       }
}

if ($home_dir =~ m/[^\/]$/) { $home_dir .= "/"; }
print "Home dir = $home_dir\n\n";

# read in old .maildelivery file

if (open(MAIL, "< $home_dir.maildelivery")) 
{
    @mail = <MAIL>;
    close(MAIL);
}
else 
{
    # Change this to 'Should I create it for you?'
    warn "** Could not open $home_dir.maildelivery file (I'll create it for you)\n";
}

# creating new .maildelivery file

if (open(MAIL, "> $home_dir.maildelivery"))
{
    print MAIL "* - ^ ? $cur_dir$script[1]\n";
    foreach $line (@mail) { 
	print MAIL $line unless (($line =~ m/ifilter/) || ($line =~ m/default/));
    }
    print MAIL "default - ^ ? \"${rcvstore_dir}rcvstore +inbox\"\n";
    close(MAIL);
    $write_maildelivery = "true";

    chmod(0644, "$home_dir.maildelivery");
} 
else
{ 
    warn "** Could not create $home_dir.maildelivery file!\n"; 
    $write_maildelivery = "false";
}



# if perl resides in a location other than /usr/bin/, open up the two scripts,
#   and replace the #! line with the actual location

if (($perl_dir ne $perl_default) || ($rcvstore_dir ne $rcvstore_default) ||
    ($refile_dir ne $refile_default)) 
{
    print "Modifying ifilter \& irefile to reflect new location of perl...\n";

    foreach $file (@script)
    {
	open(IN, "< $cur_dir$file") || die "Could not open $cur_dir$file for reading\n";
	
	@stuff = <IN>;
	
	open(OUT, "> $cur_dir$file") || 
	    die "Could not open $cur_dir$file for writing\n";
	
	foreach $line (@stuff) {
	    $line =~ s/#!\/usr\/bin\/perl/#!${perl_dir}perl/;
	    $line =~ s/\/usr\/lib\/mh\/rcvstore/${rcvstore_dir}rcvstore/;
            $line =~ s/\/usr\/bin\/mh\/rmm/${refile_dir}rmm/;
	    print OUT $line;
	}
	close(IN);
	close(OUT);
    }
    chmod 0755, "$script[0]";
    chmod 0755, "$script[1]";
}



# check to see whether 'refile' is an actual binary or just a link.  If it
#   is a link, we don't want to try to back it up.  If it is an actual binary,
#   move it to refile.bak

open(LS, "ls -l ${refile_dir}refile | ") || die "Couldn't ls -l ${refile_dir}refile\n";
$_ = <LS>;
close(LS);

print "Backing up mh refile binary...\n";

if (m/^l/) {
    warn "** ${refile_dir}refile is a link, I can't back it up!\n";
    # Change this to ask the question, 'Should I remove the link?'
    print "Removing ${refile_dir}refile...\n";
    system "rm", "${refile_dir}refile";
} else {
    system "mv", "${refile_dir}refile", "${refile_dir}refile.bak";
}

# link 'refile' to the location of irefile
print "Creating link from ${refile_dir}refile to irefile...\n";

system "ln", "-s", "$cur_dir$script[0]", "${refile_dir}refile";



# if the writing of .maildelivery didn't work, tell the user what to do.

if ($write_maildelivery eq "false") {
    print "\nPlease add the following line to the top of your .maildelivery";
    print "file:\n(it is necessary for anyone who wishes to use this";
    print "filtering system)\n\n";
    print "* - ^ ? $cur_dir$script[1]\n";
}

print "\nRemember to set your default incorporate method to presort.\n";

print "All done!\n";



